# luamon

luamon 是 unity for lua 实时运行工具。

在游戏开发过程中，很多时候游戏的当前状态不是那么容易重现，需要经过一系列的诸如登录、选服、添加机器人、匹配之类的操作，才能回到上次的状态，非常耗费时间。如果每次修改代码都要经历以上阶段，那可太痛苦了。

luamon 可在当前游戏状态快速修改逻辑或验证方法。理论上来说，如果项目框架允许，可完全实现所有 lua 文件的热重载。同时 luamon 也集成了游戏日志输出功能，方便开发阶段的真机调试。

其原理非常简单，在游戏中启动一个 Socket 服务。Client 端运行时自动与服务进行连接，本地修改的 `*.lua` 文件将实时提交到服务器 lua 虚拟中执行，并将结果返回本地。


## 常见问题

- 为什么客户端是命令行（CLI）形式的？
  - 方便与任何 IDE 集成，充分利用起 IDE 现成的自动提示、断点、调用堆栈等功能
  - 跨平台（Mac上暂未测试，理论上支持）
- 如何只监听部分文件？
  - 添加参数 `--test` 启动，则只监听 `*@test.lua` 的文件
- 接入日志方法了，如何查看日志？
  - 添加参数 `--log` 启动才会输出日志到终端
  - 只输出错误日志 `--log 0`
  - 只输出警告日志 `--log 1`
  - 只输出正常日志 `--log 2`
- 如何启用热重载？
  - 添加参数 `--hotload` 将告诉服务器需要使用热重载（功能需要根据框架自行实现，实现方式参照上文）
  - 热重载过程中 `*@test.lua` 文件依然不会被热重载，仅将其内容丢进 lua 虚拟机运行（以方便测试）
- 如何连接真机？
  - 运行 luamon 时指定真机IP即可，如：`luamon 192.168.1.3` 或 `luamon 192.168.1.3:43996`
