const formatDate = require('./formatDate'),
    style = require('./style'),
    line = new Array(60).join("=");

const log = (title)=>{
    const log = {},
        sign = style('cyan',`[${title || "LuaMon"}]`);
    log.error = (...args)=>{                                                                        // 00@
        console.log(`${sign} ${style('red','错误')} ${style('gray',formatDate(new Date))}`);
        let argsStr = args.join(",");
        if(args.length == 0 || argsStr === ""){
            return
        };
        console.log(style('gray',line));
        console.log(style('red',argsStr+"\r\n"));
    };
    log.warning = (...args)=>{                                                                      // 01@
        console.log(`${sign} ${style('yellow','警告')} ${style('gray',formatDate(new Date))}`);
        let argsStr = args.join(",");
        if(args.length == 0 || argsStr === ""){
            return
        };
        console.log(style('gray',line));
        console.log(style('yellow',argsStr+"\r\n"));
    };
    log.info = (...args)=>{                                                                         // 02@
        console.log(`${sign} ${style('white','信息')} ${style('gray',formatDate(new Date))}`);
        let argsStr = args.join(",");
        if(args.length == 0 || argsStr === ""){
            return
        };
        console.log(style('gray',line));
        console.log(style('white',argsStr+"\r\n"));
    };
    log.success = (...args)=>{                                                                      // 03@
        console.log(`${sign} ${style('green','成功')} ${style('gray',formatDate(new Date))}`);
        let argsStr = args.join(",");
        if(args.length == 0 || argsStr === ""){
            return
        };
        console.log(style('gray',line));
        console.log(style('green',argsStr+"\r\n"));
    };
    log.print = (...args)=>{
        let str = args.join(",");
        console.log(`${sign} ${style('magenta',str)}`);
    };
    return log;
};
module.exports = log;